%              ********************************************
%                          "IN THE NAME OF GOD"
%         ********************************************************
%         *              Tow-way Buffer Relaying                 *
%         *                  Prof.  Schober                      *
%         *                   Vahid Jamali                       *
%         ********************************************************
%% ---------------------------<< INTRODUCTION >>---------------------------

%% --------------------------<< INITIALIZATION >>--------------------------
clc
close all
close all

% Name of the saved plot:
savename    = ['Rate_Alpha'];

% Loead file:

load Data_rate_alpha_d500

% Legend Aspect Ratio
LegAR       = [2.5 1.2 1];
correction_value = [0 -10 -15 +10].';

plot_title  = [];

% Configuration of the axis

x = alpha ;
axis_conf   = [10^(-5) 1 10^(-5) 1];

% Colors:

c_red       = [1   , 0    , 0  ];
c_orange    = [1   , 0.55 , 0  ];
c_green     = [0   , 0.5  , 0  ];
c_blue      = [0   , 0    , 1  ];
c_black     = [0   , 0    , 0  ];
c_purple    = [0.4 , 0    , 0.4];
c_olive     = [0.4 , 0.4  , 0  ];
c_gray      = [0.5 , 0.5  , 0.5];
colors   = {c_blue, c_red, c_green, c_orange, c_purple, c_black, c_gray};

% Line width:

% line_style   = {'-','--','-.',':','o','s','d','h','*','>','<'};
line_style   = {'-','-o','s','x','h'};
line_width  = 2;
markersize = 7;


%% ------------------------------<< FIGURE >>------------------------------

h = figure;
figure1 = h;
hf1 = h;

% Create axes
ax1 = axes('Parent',hf1);
hold on;

grid off;
alpha_ext = [0 alpha];

for Index = [1 15 18 23]
    
    %PLOT1 = plot(alpha_ext,C_ub(Index)*ones(1,length(alpha)+1)*1e-6, line_style{1}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
    hold on
    
    C_sum_opt = reshape(C_sum(1,Index,:),1,20);
    PLOT2 = plot(alpha,C_sum_opt*1e-6, line_style{2}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{1});
    
    %     [Cmax,Ind_max] = max(reshape(C_sum(1,Index,:),1,20));
    %     PLOT3 = plot(alpha(Ind_max),Cmax*1e-6, line_style{5}, 'LineWidth', line_width, 'MarkerSize', markersize+1, 'Color', colors{4});
    alpha_Intrp = [0:0.001:1];
    C_sum_Intrp = interp1(alpha,C_sum_opt,alpha_Intrp) ;
    alpha_min = 0;
    alpha_max = 1;
    
    Rho = (sqrt(5)-1)/(sqrt(5)+1);
    N = 10;
    
    for ii=1:N
        Delta = alpha_max-alpha_min;
        alpha1 = alpha_min+Rho*Delta;
        alpha2 = alpha_max-Rho*Delta;
        
        [Val, Idx1] = min(abs(alpha1-alpha_Intrp)) ;
        C1 = C_sum_Intrp(Idx1) ;
        [Val, Idx2] = min(abs(alpha2-alpha_Intrp)) ;
        C2 = C_sum_Intrp(Idx2) ;
        if C1>C2
            alpha_max = alpha2 ;
        else
            alpha_min = alpha1 ;
        end
        
    end
    
    alpha_opt = mean([alpha_min,alpha_max]);
    [Val, Idx] = min(abs(alpha_opt-alpha_Intrp)) ;
        C_max = C_sum_Intrp(Idx) ;
   
    PLOT3 = plot(alpha_max,C_max*1e-6, line_style{5}, 'LineWidth', line_width, 'MarkerSize', markersize+1, 'Color', colors{4});
    
    
    
    
    
   % PLOT4 = plot(alpha(end),C_weiyu(Index)*1e-6, line_style{4}, 'LineWidth', line_width, 'MarkerSize', markersize+3, 'Color', colors{2});
      %  PLOT5 = plot(alpha_ext(end),C_lb(Index)*1e-6, line_style{3}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{3});

end



set(gca,'XMinorTick','on');
% set(gca,'YTick',[]);
% set(gca,'XTick',[0 1]);
% %title('GGN');
xlabel('$\alpha_0$','fontsize',18);
ylabel('$C_{\mathrm{sum}}$ (Mbps)','fontsize',18);

legend_text1={ 'Proposed Hybrid RF/FSO-VQ for each $\alpha_0$','Proposed Hybrid RF/FSO-VQ for $\alpha_0^*$ using GSS'};
hplots=[PLOT2,PLOT3];
%[hleg,hobjs,hlinpatches,legtxt] = legend(hplots, legend_text1,'Location','NorthWest');

axis([0 1 0 1800])
box on

text(0.02,1100,'$\kappa=10^{-3}*[0.43, 60, 75, 100]$','fontsize',12)

% Create arrow
annotation(figure1,'arrow',[0.424962852897474 0.281609195402299],...
    [0.109126984126984 0.444117647058824],'HeadLength',6,'HeadWidth',6);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% FigureNEW = axes('position',get(gca,'position'),'visible','off');

% hold on
% PLOT4 = plot(M_tot,-10*ones(1,length(M_tot)), line_style{10}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
% PLOT5 = plot(M_tot,-10*ones(1,length(M_tot)), line_style{11}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
%
% axis([1 10 0 650])

% plot_Legend2 = [PLOT4,PLOT5];
% legend_text2={ 'Buffer-Aided Protocols', 'Non-Buffer-Aided Protocols'};
% legend2 = legend(plot_Legend2,legend_text2,'Location','SouthEast');

%% ----------------------------<< EPS & TEX >>-----------------------------

% Save the figure to a EPS and a MATLAB file
if verLessThan('matlab', '7.14.0')
    preparePlotForExport('twocolumn', h, 'LegendFix', false, 'LegendAspectRatio', LegAR, 'LegendExtraSpace', '-0.5em');
else
    preparePlotForExport('twocolumn', h, 'LegendFix', false, 'LegendExtraSpace', '0.5em');
end
%%
if 1
    matlabfrag(savename);
    correct_boundingbox([], [savename '.eps'], correction_value);
    %saveas(h,[path save_dir savename '.eps'],'psc2');
    %saveas(h,[path save_dir savename '.fig'],'fig');
end;
