%              ********************************************
%                          "IN THE NAME OF GOD"
%         ********************************************************
%         *              Tow-way Buffer Relaying                 *
%         *                  Prof.  Schober                      *
%         *                   Vahid Jamali                       *
%         ********************************************************
%% ---------------------------<< INTRODUCTION >>---------------------------

%% --------------------------<< INITIALIZATION >>--------------------------
clc
close all
close all

% Name of the saved plot:
savename    = ['Rate_dfrhl'];

% Loead file:

load Data_rate_d_K4

% Legend Aspect Ratio
LegAR       = [2.5 1.2 1];
correction_value = [0 -10 -15 +10].';

plot_title  = [];

% Configuration of the axis

x = d_frhl_tot ;
axis_conf   = [10^(-5) 1 10^(-5) 1];

% Colors:

c_red       = [1   , 0    , 0  ];
c_orange    = [1   , 0.55 , 0  ];
c_green     = [0   , 0.5  , 0  ];
c_blue      = [0   , 0    , 1  ];
c_black     = [0   , 0    , 0  ];
c_purple    = [0.4 , 0    , 0.4];
c_olive     = [0.4 , 0.4  , 0  ];
c_gray      = [0.5 , 0.5  , 0.5];
colors   = {c_blue, c_red, c_green, c_orange, c_purple, c_black, c_gray};

% Line width:

% line_style   = {'-','--','-.',':','o','s','d','h','*','>','<'};
line_style   = {'-','-o','-s','-x','--o','--s','--x','-.o','-.s','-.x', ...
    'o','s','x','--','-.'};
line_width  = 2;
markersize = 7;


%% ------------------------------<< FIGURE >>------------------------------

h = figure;
figure1 = h;
hf1 = h;

% Create axes
ax1 = axes('Parent',hf1);
hold on;

grid off;

%plot(d_frhl_tot,mean(C_ub)*ones(1,length(d_frhl_tot))*1e-6, line_style{1}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
hold on
plot(d_frhl_tot,C_sum_opt*1e-6, line_style{2}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{1});
plot(d_frhl_tot,C_lb*1e-6, line_style{3}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{3});
plot(d_frhl_tot,C_weiyu*1e-6, line_style{4}, 'LineWidth', line_width, 'MarkerSize', markersize+3, 'Color', colors{2});

load Data_rate_d_K42

plot(d_frhl_tot,C_sum_opt*1e-6, line_style{5}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{1});
plot(d_frhl_tot,C_lb*1e-6, line_style{6}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{3});
plot(d_frhl_tot,C_weiyu*1e-6, line_style{7}, 'LineWidth', line_width, 'MarkerSize', markersize+3, 'Color', colors{2});

load Data_rate_d_K125

plot(d_frhl_tot,C_sum_opt*1e-6, line_style{8}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{1});
plot(d_frhl_tot,C_lb*1e-6, line_style{9}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{3});
plot(d_frhl_tot,C_weiyu*1e-6, line_style{10}, 'LineWidth', line_width, 'MarkerSize', markersize+3, 'Color', colors{2});


PLOT1 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{1}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
hold on
PLOT4 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{12}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{3});
PLOT2 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{11}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{1});
PLOT3 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{13}, 'LineWidth', line_width, 'MarkerSize', markersize+3, 'Color', colors{2});




set(gca,'XMinorTick','on');
% set(gca,'YTick',[]);
% set(gca,'XTick',[0 1]);
% %title('GGN');
xlabel('$d^{\mathrm{fr}}$ (m)','fontsize',18);
ylabel('$C_{\mathrm{sum}}$ (Mbps)','fontsize',18);

axis([100 1000 0 2200])
box on

legend_text1={'Proposed Hybrid RF/FSO-VQ','FSO-VQ','FSO-SQ'};
hplots=[PLOT2,PLOT3,PLOT4];
[hleg,hobjs,hlinpatches,legtxt] = legend(hplots, legend_text1,'Location','NorthWest');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FigureNEW = axes('position',get(gca,'position'),'visible','off');

hold on
PLOT5 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{1}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
PLOT6 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{14}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});
PLOT7 = plot(d_frhl_tot,-100*ones(1,length(d_frhl_tot)), line_style{15}, 'LineWidth', line_width, 'MarkerSize', markersize, 'Color', colors{6});

axis([100 1000 0 2200])

plot_Legend2 = [PLOT5,PLOT6,PLOT7];
legend_text2={ '$\kappa=4.2*10^{-3}$','$\kappa=42*10^{-3}$','$\kappa=125*10^{-3}$'};
legend2 = legend(plot_Legend2,legend_text2,'Location','NorthEast');

text(150,1750,'160 Mbps gain','fontsize',12)
text(420,220,'650 Mbps gain','fontsize',12)
text(900,550,'230','fontsize',12)
text(900,450,'Mbps','fontsize',12)
text(900,350,'gain','fontsize',12)


% Create doublearrow
annotation(figure1,'doublearrow',[0.389194915254237 0.388135593220339],...
    [0.110904761904762 0.351575456053068],'Head2Length',6,'Head2Width',6,...
    'Head1Length',6,...
    'Head1Width',6);

% Create doublearrow
annotation(figure1,'doublearrow',[0.174576271186441 0.174237288135593],...
    [0.650082918739637 0.727927031509123],'Head2Length',6,'Head2Width',6,...
    'Head1Length',6,...
    'Head1Width',6);

% Create doublearrow
annotation(figure1,'doublearrow',[0.86237288135593 0.86271186440678],...
    [0.112669983416254 0.195688225538972],'Head2Length',6,'Head2Width',6,...
    'Head1Length',6,...
    'Head1Width',6);



%% ----------------------------<< EPS & TEX >>-----------------------------

% Save the figure to a EPS and a MATLAB file
if verLessThan('matlab', '7.14.0')
    preparePlotForExport('twocolumn', h, 'LegendFix', false, 'LegendAspectRatio', LegAR, 'LegendExtraSpace', '-0.5em');
else
    preparePlotForExport('twocolumn', h, 'LegendFix', false, 'LegendExtraSpace', '0.5em');
end
%%
if 1
    matlabfrag(savename);
    correct_boundingbox([], [savename '.eps'], correction_value);
    %saveas(h,[path save_dir savename '.eps'],'psc2');
    %saveas(h,[path save_dir savename '.fig'],'fig');
end;
